package net.sf.l2j.gameserver.model.actor.instance;

import java.util.Iterator;
import java.util.StringTokenizer;
import javolution.text.TextBuilder;
import net.sf.l2j.gameserver.ai.CtrlIntention;
import net.sf.l2j.gameserver.ai.L2CharacterAI;
import net.sf.l2j.gameserver.model.L2Character;
import net.sf.l2j.gameserver.model.L2Multisell;
import net.sf.l2j.gameserver.network.L2GameClient;
import net.sf.l2j.gameserver.serverpackets.ActionFailed;
import net.sf.l2j.gameserver.serverpackets.MyTargetSelected;
import net.sf.l2j.gameserver.serverpackets.NpcHtmlMessage;
import net.sf.l2j.gameserver.serverpackets.ValidateLocation;
import net.sf.l2j.gameserver.templates.L2NpcTemplate;
import net.sf.l2ddt.engine.Npcbuffer;

public class L2BuffInstance extends L2NpcInstance
{

    public L2BuffInstance(int objectId, L2NpcTemplate template)
    {
        super(objectId, template);
    }

    public void onAction(L2PcInstance client)
    {
        if(this != client.getTarget())
        {
            client.setTarget(this);
            client.sendPacket(new MyTargetSelected(getObjectId(), 0));
            client.sendPacket(new ValidateLocation(this));
        } else
        {
            client.sendPacket(new MyTargetSelected(getObjectId(), 0));
            client.getAI().setIntention(CtrlIntention.AI_INTENTION_INTERACT, this);
            if(!isInsideRadius(client, 150, false, false))
            {
                client.sendPacket(new ActionFailed());
            } else
            {
                NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
                html.setFile((new StringBuilder("data/html/la2base/buffer/main.htm").toString()));
                html.replace("%objectId%", String.valueOf(getObjectId()));
                client.sendPacket(html);
            }
        }
    }

    public void onBypassFeedback(L2PcInstance client, String command)
	{
		boolean bFail = true;
		if (!client.isInOlympiadMode() && !client.isDead() && !client.isCursedWeaponEquiped())
		{
			StringTokenizer st = new StringTokenizer(command, " ");
			String cmd = st.nextToken();
			if (cmd.equalsIgnoreCase("chat"))
			{
				showChatWnd(client, st.nextToken());
				bFail = false;
			}
			if (cmd.equalsIgnoreCase("main"))
			{
				showChatWnd(client, "-1");
				bFail = false;
			}
			if (cmd.equalsIgnoreCase("buff"))
			{
				Npcbuffer.getInstance().useBuff(this, client, st.nextToken(), st.nextToken());
				bFail = false;
			}
			if (cmd.equalsIgnoreCase("cancel"))
			{
                                client.stopAllEffects();
				bFail = false;
			}
			if (cmd.equalsIgnoreCase("restore"))
			{
                             {
				       Npcbuffer.getInstance().useRestore(this, client, st.nextToken(), st.nextToken());
				       bFail = false;
                             }
			}
			if (cmd.equalsIgnoreCase("reload"))
			{
				Npcbuffer.getInstance().reload(client);
				bFail = false;
			}
			if (cmd.equalsIgnoreCase("multisell"))
			{
				L2Multisell.getInstance().SeparateAndSend(Integer.parseInt(st.nextToken()), client, false, 0.0D);
				bFail = false;
			}
		}
		if (bFail)
			client.sendPacket(new ActionFailed());
	}

    public void onActionShift(L2GameClient game)
    {
        L2PcInstance client = game.getActiveChar();
        if(client.isGM())
        {
            NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
            TextBuilder tb = new TextBuilder("<html><body><center><font color=\"LEVEL\">Buffer Information</font></center>");
            tb.append("<br><br><br>");
            tb.append((new StringBuilder("<br1><a action=\"bypass -h npc_")).append(getObjectId()).append("_reload\">Reload buff.txt</a>").toString());
            tb.append((new StringBuilder("<br1><a action=\"bypass -h npc_")).append(getObjectId()).append("_storefavs\">Force to save fav.txt</a>").toString());
            tb.append("<br1><a action=\"bypass -h admin_kill\">Kill</a>");
            tb.append("<br1><a action=\"bypass -h admin_delete\">Delete</a>");
            html.setHtml(tb.toString());
            client.sendPacket(html);
            client.setTarget(this);
            client.sendPacket(new MyTargetSelected(getObjectId(), 0));
        } else
        {
            onAction(client);
        }
    }

    public void reduceCurrentHp(double d, L2Character l2character, boolean flag)
    {
    }

    public void showChatWnd(L2PcInstance client, String id)
    {
        NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
        html.setFile((new StringBuilder("data/html/la2base/buffer/").append(id.equals("-1") ? "main" : (new StringBuilder("main-")).append(id).toString()).append(".htm").toString()));
        html.replace("%objectId%", String.valueOf(getObjectId()));
        html.replace("%after%", id);
        if(id.endsWith("_repl"))
        {
			net.sf.l2ddt.engine.Npcbuffer.BuffGroup bg;
            for(Iterator iterator = Npcbuffer.buffs().values().iterator(); iterator.hasNext(); html.replace((new StringBuilder("%e")).append(bg.nId).append("i%").toString(), (new StringBuilder("&#")).append(bg.itemId).append(";").toString()))
            {
				bg = (net.sf.l2ddt.engine.Npcbuffer.BuffGroup)iterator.next();
                html.replace((new StringBuilder("%e")).append(bg.nId).append("c%").toString(), String.valueOf(bg.itemCount));
            }

        }
        client.sendPacket(html);
    }

    public void showChatWnd(L2PcInstance client, String id, int count, int item)
    {
        NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
        html.setFile((new StringBuilder("data/html/la2base/buffer/main-notenought.htm").toString()));
        html.replace("%objectId%", String.valueOf(getObjectId()));
        html.replace("%after%", id);
        html.replace("%count%", String.valueOf(count));
        html.replace("%item%", (new StringBuilder("&#")).append(item).append(";").toString());
        client.sendPacket(html);
    }

    public void showChatErrWnd(L2PcInstance client, String after, String text)
    {
        NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
        html.setFile((new StringBuilder("data/html/la2base/buffer/main-err.htm").toString()));
        html.replace("%objectId%", String.valueOf(getObjectId()));
        html.replace("%text%", text);
        html.replace("%after%", after);
        client.sendPacket(html);
    }

	@Override
	public boolean isMovementDisabled()
	{
		return true;
	}
}
