package net.sf.l2j.gameserver.model.actor.instance;

import java.util.StringTokenizer;
import net.sf.l2j.Config;
import net.sf.l2j.gameserver.network.SystemMessageId;
import net.sf.l2j.gameserver.templates.L2NpcTemplate;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;

public class L2CustomColorManagerInstance extends L2NpcInstance
{

    public L2CustomColorManagerInstance(int objectId, L2NpcTemplate template)
    {
        super(objectId, template);
    }

    public void onBypassFeedback(L2PcInstance player, String command)
    {
		if (!Config.CM_ALLOW) return;
		StringTokenizer st = new StringTokenizer(command, " ");
		String actualCommand = st.nextToken();
		if (actualCommand.equalsIgnoreCase("change_color_title"))
		{
			String colorId = st.nextToken();
			if (Config.LIST_COLOR_TITLE.contains(colorId))
			{
				if (!player.destroyItemByItemId("ChangeColorTitle", Config.CHANGE_COLOR_TITLE_ITEMID, Config.CHANGE_COLOR_TITLE_CONSUME, this, false))
				{
					player.sendPacket(new SystemMessage(SystemMessageId.NOT_ENOUGH_ITEMS));
					return;
				}
				player.getAppearance().setTitleColor(Integer.decode("0x" + colorId));
				player.broadcastUserInfo();
				player.store();
				player.sendMessage("Enjoy your new colour.");
				return;
			}
		}
		else if (actualCommand.equalsIgnoreCase("change_color_nick"))
		{
			String colorId = st.nextToken();
			if (Config.LIST_COLOR_NICK.contains(colorId))
			{
				if (!player.destroyItemByItemId("ChangeColorNick", Config.CHANGE_COLOR_NICK_ITEMID, Config.CHANGE_COLOR_NICK_CONSUME, this, false))
				{
					player.sendPacket(new SystemMessage(SystemMessageId.NOT_ENOUGH_ITEMS));
					return;
				}
				player.getAppearance().setNameColor(Integer.decode("0x" + colorId));
				player.broadcastUserInfo();
				player.store();
				player.sendMessage("Enjoy your new colour.");
				return;
			}
		}
		return;
    }

	@Override
	public boolean isMovementDisabled()
	{
		return true;
	}
}
